#############################################################################################
# Module Configuration
#############################################################################################
variable "project" {
  description = "The name of the project."
  type        = string
}

variable "environment" {
  description = "The name of the environment."
  type        = string
}

variable "cluster_name" {
  description = "The name of the EKS cluster."
  type        = string
}

variable "tags" {
  description = "Tags to be added to all resources that take them."
  type        = map(string)
  default     = {}
}

variable "external_dependencies" {
  description = "Outputs from any resource that this module should depend on."
  type        = map(string)
  default     = {}
}

#############################################################################################
# AWS variables
#############################################################################################
variable "aws_region" {
  description = "The AWS region where the cluster lives."
  type        = string
}

variable "aws_account_id" {
  description = "The id of the AWS account thay owns the cluster."
  type        = string
}

#############################################################################################
# K8S Configuration
#############################################################################################
variable "oidc_provider_url" {
  description = "The URL (without scheme) of the OpenID Connect provider of the cluster, required when `pod_iam_policy_mode = \"iam-oidc\"`."
  type        = string
}

variable "kubeconfig" {
  description = "The content for the kubeconfig file to be used when kubectl needs to be used."
  type        = string
  default     = null
}

variable "config_output_path" {
  description = "Where to save files generated by this module."
  type        = string
  default     = "./"
}

#############################################################################################
# Module service flags - these are the main switches of the module
#############################################################################################
variable "enable_aws_k8s_cni_plugin" {
  description = "Whether to take over management of AWS CNI plugin."
  type        = bool
  default     = true
}

variable "enable_aws_k8s_cni_calico_plugin" {
  description = "Whether to install AWS CNI Calico plugin."
  type        = bool
  default     = false
}

variable "enable_aws_ebs_csi_driver" {
  description = "Whether to install AWS ENS CSI driver for persistent storage."
  type        = bool
  default     = false
}

variable "enable_spot_instance_handler" {
  description = "Whether to install a spot instance termination handler."
  type        = bool
  default     = false
}

variable "enable_autoscaler" {
  description = "Whether to install a cluster autoscaler."
  type        = bool
  default     = false
}

variable "enable_aws_lb_controller" {
  description = "Whether to install a AWS load balancer controller."
  type        = bool
  default     = false
}

#############################################################################################
# AWS K8S CNI Plugin
#############################################################################################
variable "aws_k8s_cni_manifest_url" {
  description = "The url of the AWS k8s CNI plugin manifest."
  type        = string
  default     = "https://raw.githubusercontent.com/aws/amazon-vpc-cni-k8s/v1.7.10/config/v1.7/aws-k8s-cni.yaml"
}

variable "aws_k8s_cni_manifest_file" {
  description = "The local path where the AWS k8s CNI plugin manifest is stored."
  type        = string
  default     = "aws-k8s-cni.yaml"
}

#############################################################################################
# AWS K8S CNI Calico Plugin
#############################################################################################
variable "aws_k8s_cni_calico_manifest_url" {
  description = "The url of the AWS k8s CNI calico config manifest."
  type        = string
  default     = "https://raw.githubusercontent.com/aws/amazon-vpc-cni-k8s/v1.7.10/config/v1.7/calico.yaml"
}

variable "aws_k8s_cni_calico_manifest_file" {
  description = "The local path where the AWS k8s CNI calico config manifest is stored."
  type        = string
  default     = "aws-k8s-cni-calico.yaml"
}

variable "network_block_ec2_metadata" {
  description = "Whether to set a Calico GlobalNetworkPolicy blocking access to EC2 metadata endpoint."
  type        = bool
  default     = false
}

#############################################################################################
# Cluster Tiller (helm2)
#############################################################################################
variable "cluster_tiller_service_account_name" {
  description = "The name for the tiller-deploy service account."
  type        = string
  default     = "tiller"
}

variable "cluster_tiller_wait_for_timeout" {
  description = "How much to wait for tiller to be ready before breaking the terraform run."
  type        = string
  default     = "300s"
}

variable "cluster_tiller_priority_class_name" {
  description = "PriorityClass name for tiller pod."
  type        = string
  default     = "system-cluster-critical"
}

#############################################################################################
# k8s-spot-termination-handler (helm2)
#############################################################################################
variable "k8s_spot_termination_handler_helm_chart_version" {
  description = "The version of the helm chart."
  type        = string
  default     = "1.4.9"
}

variable "k8s_spot_termination_handler_container_image_tag" {
  description = "The tag of the docker image."
  type        = string
  default     = "1.13.7-1"
}

variable "k8s_spot_termination_handler_helm_values" {
  description = "Any additional Helm values to specify to k8s-spot-termination-handler Helm release."
  type        = list(string)
  default     = []
}

#############################################################################################
# Cluster Autoscaler (helm2)
#############################################################################################
variable "autoscaler_helm_chart_version" {
  description = "The version of the helm chart."
  type        = string
  default     = "7.3.1"
}

variable "autoscaler_container_image_tag" {
  description = "The tag of the docker image."
  type        = string
  default     = "v1.15.6"
}

variable "autoscaler_helm_values" {
  description = "Any additional Helm values to specify to cluster-autoscaler Helm release."
  type        = list(string)
  default     = []
}

#############################################################################################
# Global Network Policy - block EC2 metadata
#############################################################################################
variable "network_block_ec2_metadata_excluded_namespaces" {
  description = "A set of namespaces to be excluded from the Global Network Policy that blocks pods from accessing EC2 metadata endpoint. Empty means no namespace is excluded."
  type        = list(string)
  default     = []
}

#############################################################################################
# AWS EBS CSI driver
#############################################################################################
variable "aws_ebs_csi_driver_helm_chart_version" {
  description = "The version of the helm chart."
  type        = string
  default     = "1.0.0"
}

variable "ebs_csi_driver_helm_values" {
  description = "Any additional Helm values to specify to AWS EBS CSI driver release."
  type        = list(string)
  default     = []
}

#############################################################################################
# AWS LB Controller
#############################################################################################
variable "aws_load_balancer_controller_helm_chart_version" {
  description = "The version of the helm chart."
  type        = string
  default     = "1.2.2"
}

variable "aws_load_balancer_controller_resources" {
  description = "Kubernetes resources configuration."

  type = object({
    limits   = object({ cpu = string, memory = string })
    requests = object({ cpu = string, memory = string })
  })

  default = {
    limits   = { cpu = "100m", memory = "128Mi" }
    requests = { cpu = "100m", memory = "128Mi" }
  }
}

variable "aws_load_balancer_controller_lb_ssl_policy" {
  description = "The default TLS/SSL policy configured on the LBs."
  type        = string
  default     = "ELBSecurityPolicy-FS-1-2-Res-2020-10"
}
